'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSyntaxHighlighter = require('react-syntax-highlighter');

var _reactSyntaxHighlighter2 = _interopRequireDefault(_reactSyntaxHighlighter);

var _copyToClipboard = require('copy-to-clipboard');

var _copyToClipboard2 = _interopRequireDefault(_copyToClipboard);

var _atomOneDark = require('react-syntax-highlighter/dist/styles/atom-one-dark');

var _atomOneDark2 = _interopRequireDefault(_atomOneDark);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var headerStyle = function headerStyle(width) {
  return {
    boxSizing: 'border-box',
    color: 'rgb(69, 45, 45)',
    backgroundColor: 'rgb(225, 223, 225)',
    fontFamily: 'monaco, Consolas, Lucida Console, monospace',
    fontSize: 16,
    paddingBottom: 1,
    borderTopLeftRadius: 5,
    borderTopRightRadius: 5,
    width: width,
    display: 'flex',
    justifyContent: 'space-between'
  };
};

var buttonsContainer = {
  display: 'flex',
  justifyContent: 'space-between',
  width: 60,
  paddingTop: 5,
  paddingLeft: 20,
  textAlign: 'center'
};

var buttonStyle = function buttonStyle(color) {
  return {
    width: 14,
    height: 14,
    borderRadius: '50%',
    backgroundColor: color
  };
};

var copyStyle = function copyStyle(hovered) {
  return {
    marginRight: 12,
    paddingLeft: 8,
    paddingRight: 8,
    cursor: 'pointer',
    color: hovered ? '#2C1414' : 'rgb(69, 45, 45)'
  };
};

var redButton = buttonStyle('rgb(252, 100, 95)');
var yellowButton = buttonStyle('rgb(253, 191, 65)');
var greenButton = buttonStyle('rgb(54, 206, 76)');

var CodeWindow = function (_React$Component) {
  _inherits(CodeWindow, _React$Component);

  function CodeWindow(props) {
    _classCallCheck(this, CodeWindow);

    var _this = _possibleConstructorReturn(this, (CodeWindow.__proto__ || Object.getPrototypeOf(CodeWindow)).call(this, props));

    _this.onMinimize = function () {
      if (_this.props.onMinimize) {
        _this.props.onMinimize();
      } else if (_this.props.minimized === undefined) {
        _this.setState({ minimized: true });
      }
    };

    _this.onMaximize = function () {
      if (_this.props.onMaximize) {
        _this.props.onMaximize();
      } else if (_this.props.minimized === undefined) {
        _this.setState({ minimized: false });
      }
    };

    _this.state = { minimized: props.minimized || false, showMinus: false, copyHovered: false };
    return _this;
  }

  _createClass(CodeWindow, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.minimized !== undefined && nextProps.minimized !== this.state.minimized) {
        this.setState({ minimized: nextProps.minimized });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$width = _props.width,
          width = _props$width === undefined ? 500 : _props$width,
          _props$title = _props.title,
          title = _props$title === undefined ? 'react-code-window' : _props$title,
          children = _props.children,
          CopyComponent = _props.CopyComponent;

      var yellowButtonChildren = this.state.showMinus && this.props.allowMinimizeMaximize ? _react2.default.createElement(
        'span',
        { style: {
            position: 'relative',
            bottom: '5px',
            fontWeight: 600,
            fontSize: 14,
            color: 'rgba(0,0,0,0.5)',
            cursor: 'default',
            highlight: 'none'
          } },
        '\u2212'
      ) : null;
      var greenButtonChildren = this.state.showMinus && this.props.allowMinimizeMaximize ? _react2.default.createElement(
        'span',
        { style: {
            position: 'relative',
            bottom: '5px',
            fontWeight: 600,
            fontSize: 12,
            color: 'rgba(0,0,0,0.5)',
            cursor: 'default',
            highlight: 'none'
          } },
        '+'
      ) : null;
      var syntax = !this.state.minimized ? _react2.default.createElement(
        _reactSyntaxHighlighter2.default,
        {
          style: _atomOneDark2.default,
          customStyle: {
            margin: 0,
            width: 'calc(' + (typeof width === 'number' ? width + 'px' : width) + ' - 1em)'
          }
        },
        children
      ) : null;
      var copyButton = this.props.showCopy ? _react2.default.createElement(
        CopyComponent,
        {
          style: typeof this.props.copyComponentStyle === 'function' ? this.props.copyComponentStyle(this.state.copyHovered) : this.props.copyComponentStyle,
          onMouseEnter: function onMouseEnter() {
            return _this2.setState({ copyHovered: true });
          },
          onMouseLeave: function onMouseLeave() {
            return _this2.setState({ copyHovered: false });
          },
          onClick: function onClick() {
            return (0, _copyToClipboard2.default)(children);
          }
        },
        this.props.copyChildren
      ) : _react2.default.createElement('span', null);
      return _react2.default.createElement(
        'div',
        { style: { position: 'relative', width: '100%' } },
        _react2.default.createElement(
          'div',
          { style: headerStyle(width) },
          _react2.default.createElement(
            'span',
            {
              style: buttonsContainer,
              onMouseEnter: function onMouseEnter() {
                return _this2.setState({ showMinus: true });
              },
              onMouseLeave: function onMouseLeave() {
                return _this2.setState({ showMinus: false });
              }
            },
            _react2.default.createElement('div', { style: redButton }),
            _react2.default.createElement(
              'div',
              {
                style: yellowButton,
                onClick: function onClick() {
                  return _this2.props.allowMinimizeMaximize && _this2.onMinimize();
                }
              },
              yellowButtonChildren
            ),
            _react2.default.createElement(
              'div',
              {
                style: greenButton,
                onClick: function onClick() {
                  return _this2.props.allowMinimizeMaximize && _this2.onMaximize();
                }
              },
              greenButtonChildren
            )
          ),
          _react2.default.createElement(
            'span',
            null,
            title
          ),
          copyButton
        ),
        syntax
      );
    }
  }]);

  return CodeWindow;
}(_react2.default.Component);

exports.default = CodeWindow;


CodeWindow.defaultProps = {
  allowMinimizeMaximize: true,
  showCopy: true,
  CopyComponent: 'div',
  copyComponentStyle: copyStyle,
  copyChildren: 'Copy'
};